<script lang="ts">
  import type { EventResultTeams$result } from '$houdini';

  export let year: string;
  export let winner: EventResultTeams$result['final_event_results'][0]['team'] | null;
  export let teams: NonNullable<EventResultTeams$result['regional_event_results']>;
  let regions: string[];
  let teamsByRegion: Record<string, NonNullable<EventResultTeams$result['regional_event_results']>> = {};

  $: {
    regions = [...new Set(teams.map((entry) => entry.team!.institution!.regions.map(r => r.region.name)).flat())];
    for (const r of regions) {
      teamsByRegion[r] = teams.filter(entry => entry.team!.institution?.regions.map(re => re.region.name).includes(r))
    }
  }
  $: numRegions = regions.length;
</script>

<div class="flex flex-col items-center mx-auto mb-20 bg-slate-100" style="max-width: 1800px">
  {#if winner}
    <h1
      class="col-start-2 text-4xl lg:text-6xl font-semibold text-cyber-blue-900 text-center mb-5 pt-5 pb-2 px-10 uppercase">
      {year} Invitational Champion: <br /> {winner.long_name}
    </h1>
    <div class="w-4/5 md:w-2/5 flex mx-auto md:col-start-2 mb-10 md:mb-20">
      <img
      class="aspect-square object-scale-down mx-auto"
        style="object-fit: contain; max-height: 100%; max-width: 100%;"
        src={winner.institution?.img}
        alt={winner.institution?.name}
        title={winner.institution?.name} />
    </div>
  {/if}

  <h1 class="text-4xl lg:text-6xl font-semibold text-cyber-blue-900 text-center pb-2 px-10 uppercase">
    {year} Regional Champions
  </h1>

  <slot class="md:mb-10" />

  <div class="regiongrid flex flex-col md:grid text-center" style="--num-cols: {numRegions}">
    {#each regions.toSorted() as region}
      <div class="flex flex-col items-center mt-10 md:mt-0 md:border-l-2 first:border-l-0 px-10 h-100">
        <h1 class="text-2xl xl:text-4xl text-cyber-blue-900 font-semibold border-b-2 pb-2 mb-2 uppercase">
          {region}
        </h1>
        <div class="flex md:flex-col flex-wrap items-center justify-center mt-2 overflow-visible">
          {#each teamsByRegion[region] as entry}
            <div class="xl:p-4 w-full">
              <img
                class="aspect-square object-scale-down mx-auto"
                style="object-fit: contain; max-height: 150px; width: inherit;"
                src={entry.team?.institution?.img}
                alt={entry.team?.institution?.name}
                title={entry.team?.institution?.name} />
                <h6 class="py-3 font-mono font-bold">{entry.team?.long_name}</h6>
                <p class="py-3 font-mono">{entry.event?.name}</p>
            </div>
          {/each}
        </div>
      </div>
    {/each}
  </div>
</div>

<style>
  .regiongrid {
    grid-template-columns: repeat(var(--num-cols), minmax(0, 1fr));
  }
</style>
